//-------------------------------------------------------------------+
//|                                                       SSL M5.mq4 |
//|                                                     Ronnie Leano |
//|                                        ronnieleano0725@gmail.com |
//|                                                                  |
//|------------------------------------------------------------------+
#property copyright "Ronnie Leano"
#property link      "ronnieleano0725@gmail.com"
#property version   "1.00"
#property strict
#resource "ssl channel.ex4"

#define TRADE_RETRY_COUNT   4
#define TRADE_RETRY_WAIT  100
//+------------------------------------------------------------------+
//| Expert initialization function                                   |
//+------------------------------------------------------------------+

input int    TimeFrame     = 5;
input double LotSize       = 0.05;
input double ClosingProfit = 2.5;
input double GridStepMultiplier = 1;//ATR factor of Grid Step
input int    NoOrderSpeed = 1;//Testing speed without order
input int    OnOrderSpeed = 1000;//Testing speed with order
input bool   TestMode = true;//Run for backtest

string CurrencyPair  = "";
double GridStep = 0;
datetime oldBarTime;

//Custom Indicator SSL Channel
const string C0Indicator     = "::ssl channel.ex4";
const int    BufferSSL       = 0;
const int    SSLBufferValue2 = 1;

int      TotalSymbols = 3;
int      SymbolIndex = 0;
int      Magic = 0;
bool     SellSignal[];
bool     BuySignal[];
string   Symbols[];
int      MagicNum[];
int      SymbolOrders[];

//+------------------------------------------------------------------+
int OnInit()
  {
     
      oldBarTime=Time[0];
      IntializeArrays();
      
      return(INIT_SUCCEEDED);
  }
  
//+------------------------------------------------------------------+  
void IntializeArrays()
{
   
   ArrayInitialize (BuySignal, false);
   ArrayInitialize (SellSignal, false);
   ArrayInitialize (MagicNum,0);
   ArrayInitialize (SymbolOrders,0);
   
   for (int i = 1; i <=TotalSymbols; i++) 
   {
      ArrayResize(BuySignal,        ArraySize(BuySignal)+i);
      ArrayResize(SellSignal,       ArraySize(SellSignal)+i);
      ArrayResize(Symbols,          ArraySize(Symbols)+i);
      ArrayResize(MagicNum,         ArraySize(MagicNum)+i);      
      ArrayResize(SymbolOrders,     ArraySize(SymbolOrders)+i);
      
   }
      
   Symbols[1]  = "AUDCAD"; MagicNum[1]  = 47201;
   Symbols[2]  = "AUDJPY"; MagicNum[2]  = 47202;
   Symbols[3]  = "EURAUD"; MagicNum[3]  = 47206;
}

//+------------------------------------------------------------------+
//| Expert tick function                                             |
//+------------------------------------------------------------------+

void OnTick()
{ 
   
   if (TestMode) Delay(OnOrderSpeed,NoOrderSpeed);//run slow 
   
   if(oldBarTime!=Time[0])
   { 
      oldBarTime=Time[0];
      
      for (SymbolIndex = 1; SymbolIndex <=TotalSymbols; SymbolIndex++)   
      {
         CurrencyPair = Symbols[SymbolIndex];
         Magic        = MagicNum[SymbolIndex];
         EAStart();
      }
   }
}

//+------------------------------------------------------------------+
void EAStart()

{
   
      GridStep      = iATR(CurrencyPair,TimeFrame,1,1)*GridStepMultiplier;
      
      if (SymbolOrders(Magic)<1)
      {
         
         GetSignal();
         if (SellSignal[SymbolIndex] && UpReversal())
         { 
            BuySignal[SymbolIndex] = false;
            PlaceBuyMarketOrder(Magic);
         }
         
         else 
         if (BuySignal[SymbolIndex] && DownReversal())
         { 
            SellSignal[SymbolIndex] = false;
            PlaceSellMarketOrder(Magic);
         } 
       }
       
 //-------------------------------------------------------------------------------------------------
      if (LastOrderID(Magic)>0 && SellSignal[SymbolIndex])
         if (OrderSelect(LastOrderID(Magic), SELECT_BY_TICKET, MODE_TRADES)==true && OrderCloseTime()==0)
            if (UpReversal() && (OrderOpenPrice()-Close[1])>GridStep)
            {  
               PlaceBuyMarketOrder(Magic);
               
            }
//-------------------------------------------------------------------------------------------------
      
      if (LastOrderID(Magic)>0 && BuySignal[SymbolIndex])
         if (OrderSelect(LastOrderID(Magic), SELECT_BY_TICKET, MODE_TRADES)==true && OrderCloseTime()==0)
            if (DownReversal() && (Close[1] - OrderOpenPrice())>GridStep)
            { 
               PlaceSellMarketOrder(Magic);
               
            }
            
    if(SymbolProfit(Magic)> ClosingProfit) CloseSymbolOrders(Magic); //Close in group
    
 } 
//-------------------------------------------------------------------------------------------------
	void GetSignal()
	{
	   //SSL
	   int InpLb          =   14, SSLTime = 5;
      double SSL1        =	iCustom(CurrencyPair,SSLTime,C0Indicator,InpLb,BufferSSL,1);         //RED LINE
      double Value1      =	iCustom(CurrencyPair,SSLTime,C0Indicator,InpLb,SSLBufferValue2,1);   //BLUE LINE
	   
	   SellSignal[SymbolIndex]  =   Value1<SSL1; //blue line down
	   BuySignal[SymbolIndex]   =   Value1>SSL1; //blue line up
   }
//-------------------------------------------------------------------------------------------------
	bool DownReversal()
	{
	   //SSL
	   int InpLb          = 2, SSLTime = 5;
      double SSL1        =	iCustom(CurrencyPair,SSLTime,C0Indicator,InpLb,BufferSSL,1);         //RED LINE
      double SSL2        =	iCustom(CurrencyPair,SSLTime,C0Indicator,InpLb,BufferSSL,2);         //RED LINE
      double Value1      =	iCustom(CurrencyPair,SSLTime,C0Indicator,InpLb,SSLBufferValue2,1);  //BLUE LINE	
      double Value2      =	iCustom(CurrencyPair,SSLTime,C0Indicator,InpLb,SSLBufferValue2,2);  //BLUE LINE
	  
	   bool Reversal      = Value1<SSL1 && Value2>SSL2; //blue down on 1
	   return (Reversal);
	}	
//-------------------------------------------------------------------------------------------------
	bool UpReversal()
	{
	   //SSL
	   int InpLb          = 2, SSLTime = 5;
      double SSL1        =	iCustom(CurrencyPair,SSLTime,C0Indicator,InpLb,BufferSSL,1);         //RED LINE
      double SSL2        =	iCustom(CurrencyPair,SSLTime,C0Indicator,InpLb,BufferSSL,2);         //RED LINE
      double Value1      =	iCustom(CurrencyPair,SSLTime,C0Indicator,InpLb,SSLBufferValue2,1);  //BLUE LINE	
      double Value2      =	iCustom(CurrencyPair,SSLTime,C0Indicator,InpLb,SSLBufferValue2,2);  //BLUE LINE
	  
	   bool Reversal      = Value1>SSL1 && Value2<SSL2; //blue up on 1
	   return (Reversal);
	}
	
//+------------------------------------------------------------------+
void PlaceBuyMarketOrder(int MagicNumber)
{
   for (int attempt = 0; attempt < TRADE_RETRY_COUNT; attempt++)
   {
      int OrderID             = 0;
      int LastError           = 0;
      bool modified           = false;
      
      if (IsTradeContextFree())
      {
         // Send an entry order without SL and TP
         OrderID = OrderSend(CurrencyPair,OP_BUY,LotSize,MarketInfo (CurrencyPair, MODE_ASK),10,0,0,NULL,MagicNumber,0,clrNONE);
      }    
      if (OrderID > 0)
      { 
         break;  //stop trying to place an order
      }
       
      LastError = GetLastError();

      if (LastError != 135 && LastError != 136 && LastError != 137 && LastError != 138)
         break;

      Sleep(TRADE_RETRY_WAIT);
      Print("Open Position retry no: " + IntegerToString(attempt + 2)); 
   }
 }        
//+------------------------------------------------------------------+
void PlaceSellMarketOrder(int MagicNumber)
{
   for (int attempt = 0; attempt < TRADE_RETRY_COUNT; attempt++)
   {
      int OrderID             = 0;
      int LastError           = 0;
      bool modified           = false;
      
      if (IsTradeContextFree())
      {
      
      // Send an entry order without SL and TP
      OrderID = OrderSend(CurrencyPair,OP_SELL,LotSize,MarketInfo (CurrencyPair, MODE_BID),10,0,0,NULL,MagicNumber,0,clrNONE);
      
      }
      if (OrderID > 0)
      { 
         break;  //stop trying to place an order
      }
       
      LastError = GetLastError();

      if (LastError != 135 && LastError != 136 && LastError != 137 && LastError != 138)
         break;

      Sleep(TRADE_RETRY_WAIT);
      Print("Open Position retry no: " + IntegerToString(attempt + 2));
   }
 }  
//+------------------------------------------------------------------+
bool IsTradeContextFree()
  {
   if ( IsTradeAllowed() )
      return true;

   uint startWait = GetTickCount();
   Print("Trade context is busy! Waiting...");

   while (true)
     {
      if ( IsStopped() )
         return false;

      uint diff = GetTickCount() - startWait;
      if (diff > 30 * 1000)
        {
         Print("The waiting limit exceeded!");
         return false;
        }

      if ( IsTradeAllowed() )
        {
         RefreshRates();
         return true;
        }

      Sleep(TRADE_RETRY_WAIT);
     }

   return true;
  }

//+-----------------------------------------------------------------------------------------------------
int LastOrderID(int MagicNumber)
{
  
   int OrderID = 0;
   //Find last order of Symbol
   int total = OrdersTotal();
   for(int i=total-1;i>=0;i--)
   {
      if (OrderSelect(i, SELECT_BY_POS, MODE_TRADES)==true && OrderCloseTime()==0)
         if (OrderMagicNumber()== MagicNumber) 
         {
            OrderID   = OrderTicket();
            break;
         }   
   } 
   
   return(OrderID);
}

//+-----------------------------------------------------------------------------------------------------
double SymbolProfit(int MagicNumber)
{
   double Profit = 0;
   int total = OrdersTotal();
   for(int i=total-1;i>=0;i--)
   { 
      if (OrderSelect(i, SELECT_BY_POS, MODE_TRADES)==true && OrderMagicNumber() == MagicNumber && OrderCloseTime()==0)
      { 
         Profit = Profit + OrderProfit()+ OrderCommission() + OrderSwap();         
      }
      else
      {
        Print ("Error with OrderSelect 5 = " + IntegerToString(GetLastError()));
      }
   }
   return(Profit);
}
//+-----------------------------------------------------------------------------------------------------
void CloseSymbolOrders(int MagicNumber)
{  
    int total = OrdersTotal();
    for(int i=total-1;i>=0;i--)
    {
      if (OrderSelect(i, SELECT_BY_POS, MODE_TRADES)==true && OrderMagicNumber()== MagicNumber && OrderCloseTime()==0)
      {
         for (int attempt = 0; attempt < TRADE_RETRY_COUNT; attempt++)
         {
            bool closed    = 0;
            int  lastError = 0;
            if ( IsTradeContextFree() )
            {
               if (OrderType()==OP_BUY)
               closed = OrderClose(OrderTicket(), OrderLots(), MarketInfo(OrderSymbol(), MODE_BID), 10, clrNONE);
               
               if (OrderType()==OP_SELL)
               closed = OrderClose(OrderTicket(), OrderLots(), MarketInfo(OrderSymbol(), MODE_ASK), 10, clrNONE);
            }
            
            if (closed)
            break;
            
            if (lastError == 4108)
            break;
   
            Sleep(TRADE_RETRY_WAIT);
            Print("Close Position retry no: " + IntegerToString(attempt + 2));
         }
      }
      else
      {
         Print ("Error with OrderSelect = " + IntegerToString(GetLastError()));
      }
    }
 }

//+-----------------------------------------------------------------------------------------------------
int SymbolOrders(int MagicNumber)
{
   int Orders = 0;
   int total = OrdersTotal();
   for(int i=total-1;i>=0;i--)
   { 
      if (OrderSelect(i, SELECT_BY_POS, MODE_TRADES)==true && OrderMagicNumber() == MagicNumber && OrderCloseTime()==0)
      { 
         Orders++;
      }
      else
      { 
        Print ("Error with OrderSelect 1 = " + IntegerToString(GetLastError()));
      }
   }    
   
   return(Orders);
}

//+------------------------------------------------------------------+
void Delay(int Slow, int Fast)
{
   int SpeedValue;
   
   if (OrdersTotal()>0)
      {SpeedValue = Slow;}
	else
	   {SpeedValue = Fast;}
	   	   
   for (int i=SpeedValue; i>0; i--) Comment("0");
}
//+------------------------------------------------------------------+
